﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NonaBGS.Journal;

namespace NonaBGS.BGS {
    public class SellMicroResources : LogEntry {
        public SellMicroResources(string system, string station) {
            System = system;
            Station = Station;
        }

        public int TotalSum {
            get {
                return Entries
                       .Where(x => x.GetType() == typeof(SellMicroResourcesEntry))
                       .Sum(x => (x as SellMicroResourcesEntry).Price)
                       ;
            }
        }

        public override string ToString() {
            return string.Format("Sell Micro Resources: {0} CR", TotalSum);
        }
    }
}
